import { AfterViewInit, DoCheck, ElementRef, EventEmitter, KeyValueDiffers, NgZone, OnDestroy } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { Editor, EditorChangeLinkedList, EditorFromTextArea } from 'codemirror';
import { MatFormFieldControl } from '@angular/material';
import { Subject } from 'rxjs/Subject';
export declare class MatCodemirrorComponent implements AfterViewInit, OnDestroy, ControlValueAccessor, MatFormFieldControl<string>, DoCheck {
    ngControl: NgControl;
    private _differs;
    private _ngZone;
    static materialId: number;
    stateChanges: Subject<void>;
    id: string;
    controlType: string;
    describedBy: string;
    setDescribedByIds(ids: string[]): void;
    onContainerClick(event: MouseEvent): void;
    readonly errorState: boolean;
    placeholder: string;
    private _placeholder;
    readonly focused: boolean;
    readonly empty: boolean;
    readonly shouldLabelFloat: boolean;
    required: boolean;
    private _required;
    className: string;
    name: string;
    autoFocus: boolean;
    /**
     * set options for codemirror
     * @link http://codemirror.net/doc/manual.html#config
     */
    options: {
        [key: string]: any;
    };
    preserveScrollPosition: boolean;
    cursorActivity: EventEmitter<any>;
    focusChange: EventEmitter<boolean>;
    scroll: EventEmitter<any>;
    ref: ElementRef;
    _value: string;
    value: string;
    _disabled: boolean;
    disabled: boolean;
    _isFocused: boolean;
    isFocused: boolean;
    codeMirror: EditorFromTextArea;
    private _differ;
    private _options;
    constructor(ngControl: NgControl, _differs: KeyValueDiffers, _ngZone: NgZone);
    ngAfterViewInit(): void;
    ngDoCheck(): void;
    ngOnDestroy(): void;
    codemirrorValueChanged(cm: Editor, change: EditorChangeLinkedList): void;
    setOptionIfChanged(optionName: string, newValue: any): void;
    focusChanged(focused: boolean): void;
    scrollChanged(cm: Editor): void;
    cursorActive(cm: Editor): void;
    /** Implemented as part of ControlValueAccessor. */
    writeValue(value: string): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: string) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: () => void): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
    /** Implemented as part of ControlValueAccessor. */
    private onChange;
    /** Implemented as part of ControlValueAccessor. */
    private onTouched;
    private normalizeLineEndings(str);
}
